--- include/class.support.php	2009-01-18 23:08:52.000000000 +0200
+++ /usr/share/eventum/include/class.support.php	2009-02-05 02:15:18.663988299 +0200
@@ -27,20 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "class.error_handler.php");
-require_once(APP_INC_PATH . "class.auth.php");
-require_once(APP_INC_PATH . "class.user.php");
-require_once(APP_INC_PATH . "class.pager.php");
-require_once(APP_INC_PATH . "class.mail.php");
-require_once(APP_INC_PATH . "class.note.php");
-require_once(APP_INC_PATH . "class.misc.php");
-require_once(APP_INC_PATH . "class.mime_helper.php");
-require_once(APP_INC_PATH . "class.date.php");
-require_once(APP_INC_PATH . "class.history.php");
-require_once(APP_INC_PATH . "class.issue.php");
-require_once(APP_INC_PATH . "class.email_account.php");
-require_once(APP_INC_PATH . "class.search_profile.php");
-require_once(APP_INC_PATH . "class.routing.php");
 
 /**
  * Class to handle the business logic related to the email feature of
@@ -72,7 +58,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_id IN (" . implode(', ', Misc::escapeInteger($sup_ids)) . ")";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -124,7 +110,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_id=" . Misc::escapeInteger($sup_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -133,7 +119,7 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email_body
                      WHERE
                         seb_sup_id=" . Misc::escapeInteger($sup_id);
-            $res = $GLOBALS["db_api"]->dbh->query($stmt);
+            $res = Db_Helper::getInstance()->query($stmt);
             if (PEAR::isError($res)) {
                 Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
                 return false;
@@ -175,7 +161,7 @@
         $stmt .= "
                  ORDER BY
                     " . $options["sort_by"] . " " . $options["sort_order"];
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -223,7 +209,7 @@
                     sup_iss_id=" . Misc::escapeInteger($issue_id) . "
                  ORDER BY
                     sup_id ASC";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -284,7 +270,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_id IN (" . implode(", ", Misc::escapeInteger($sup_ids)) . ")";
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -326,7 +312,7 @@
                     sup_removed=0
                  WHERE
                     sup_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -357,13 +343,13 @@
                     ema_prj_id=" . Auth::getCurrentProject() . " AND
                     ema_id=sup_ema_id AND
                     sup_removed=1";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
         } else {
             for ($i = 0; $i < count($res); $i++) {
-                $res[$i]["sup_date"] = Date_API::getFormattedDate($res[$i]["sup_date"]);
+                $res[$i]["sup_date"] = Date_Helper::getFormattedDate($res[$i]["sup_date"]);
                 $res[$i]["sup_subject"] = Mime_Helper::fixEncoding($res[$i]["sup_subject"]);
                 $res[$i]["sup_from"] = Mime_Helper::fixEncoding($res[$i]["sup_from"]);
             }
@@ -390,7 +376,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_ema_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -467,7 +453,7 @@
     function bounceMessage($message, $error)
     {
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/bounced_email.tpl.text');
         $tpl->bulkAssign(array(
             'error_code'        => $error[0],
@@ -479,7 +465,7 @@
             'cc'                => Mime_Helper::fixEncoding(@$message->ccaddress),
         ));
 
-        $sender_email = Mail_API::getEmailAddress($message->fromaddress);
+        $sender_email = Mail_Helper::getEmailAddress($message->fromaddress);
         $usr_id = User::getUserIDByEmail($sender_email);
         // change the current locale
         if ($usr_id) {
@@ -489,7 +475,7 @@
         $text_message = $tpl->getTemplateContents();
 
         // send email (use PEAR's classes)
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($text_message);
         $setup = $mail->getSMTPSettings();
         $mail->send($setup['from'], $sender_email,
@@ -532,7 +518,7 @@
             // XXX do some error reporting?
             return;
         }
-        $message_id = Mail_API::getMessageID($headers, $body);
+        $message_id = Mail_Helper::getMessageID($headers, $body);
         $message = $headers . $body;
         // we don't need $body anymore -- free memory
         unset($body);
@@ -551,7 +537,7 @@
         }
         // we can't trust the in-reply-to from the imap c-client, so let's
         // try to manually parse that value from the full headers
-        $reference_msg_id = Mail_API::getReferenceMessageID($headers);
+        $reference_msg_id = Mail_Helper::getReferenceMessageID($headers);
 
         // pass in $email by reference so it can be modified
         $workflow = Workflow::preEmailDownload($info['ema_prj_id'], $info, $mbox, $num, $message, $email, $structure);
@@ -643,7 +629,7 @@
             return;
         }
 
-        $sender_email = Mail_API::getEmailAddress($email->fromaddress);
+        $sender_email = Mail_Helper::getEmailAddress($email->fromaddress);
         if (PEAR::isError($sender_email)) {
             $sender_email = 'Error Parsing Email <>';
         }
@@ -651,7 +637,7 @@
         $t = array(
             'ema_id'         => $info['ema_id'],
             'message_id'     => $message_id,
-            'date'           => Date_API::convertDateGMTByTS($email->udate),
+            'date'           => Date_Helper::convertDateGMTByTS($email->udate),
             'from'           => $sender_email,
             'to'             => @$email->toaddress,
             'cc'             => @$email->ccaddress,
@@ -706,11 +692,11 @@
                         $users = array_flip($users);
 
                         $addresses = array();
-                        $to_addresses = Mail_API::getEmailAddresses(@$structure->headers['to']);
+                        $to_addresses = Mail_Helper::getEmailAddresses(@$structure->headers['to']);
                         if (count($to_addresses)) {
                             $addresses = $to_addresses;
                         }
-                        $cc_addresses = Mail_API::getEmailAddresses(@$structure->headers['cc']);
+                        $cc_addresses = Mail_Helper::getEmailAddresses(@$structure->headers['cc']);
                         if (count($cc_addresses)) {
                             $addresses = array_merge($addresses, $cc_addresses);
                         }
@@ -723,7 +709,7 @@
 
                         // XXX FIXME, this is not nice thing to do
                         $_POST = array(
-                            'title'                => Mail_API::removeExcessRe($t['subject']),
+                            'title'                => Mail_Helper::removeExcessRe($t['subject']),
                             'note'                 => $t['body'],
                             'note_cc'              => $cc_users,
                             'add_extra_recipients' => 'yes',
@@ -738,7 +724,7 @@
             // check if we need to block this email
             if (($should_create_issue == true) || (!Support::blockEmailIfNeeded($t))) {
                 if (!empty($t['issue_id'])) {
-                    list($t['full_email'], $t['headers']) = Mail_API::rewriteThreadingHeaders($t['issue_id'], $t['full_email'], $t['headers'], 'email');
+                    list($t['full_email'], $t['headers']) = Mail_Helper::rewriteThreadingHeaders($t['issue_id'], $t['full_email'], $t['headers'], 'email');
                 }
 
                 // make variable available for workflow to be able to detect whether this email created new issue
@@ -771,7 +757,7 @@
                         Notification::notifyNewEmail(Auth::getUserID(), $t['issue_id'], $t, $internal_only, $assignee_only, '', $sup_id);
 
                         // try to get usr_id of sender, if not, use system account
-                        $addr = Mail_API::getEmailAddress($structure->headers['from']);
+                        $addr = Mail_Helper::getEmailAddress($structure->headers['from']);
                         if (PEAR::isError($addr)) {
                             // XXX should we log or is this expected?
                             Error_Handler::logError(array($addr->getMessage()." addr: $addr", $addr->getDebugInfo()), __FILE__, __LINE__);
@@ -840,9 +826,9 @@
 
         // we can't trust the in-reply-to from the imap c-client, so let's
         // try to manually parse that value from the full headers
-        $references = Mail_API::getAllReferences($headers);
+        $references = Mail_Helper::getAllReferences($headers);
 
-        $message_id = Mail_API::getMessageID($headers, $message_body);
+        $message_id = Mail_Helper::getMessageID($headers, $message_body);
         $workflow = Workflow::getIssueIDforNewEmail($info['ema_prj_id'], $info, $headers, $message_body, $date, $from, $subject, $to, $cc);
         if ($workflow == 'new') {
             $should_create_issue = true;
@@ -909,7 +895,7 @@
             }
         }
 
-        $sender_email = Mail_API::getEmailAddress($from);
+        $sender_email = Mail_Helper::getEmailAddress($from);
         if (PEAR::isError($sender_email)) {
             $sender_email = 'Error Parsing Email <>';
         }
@@ -949,7 +935,7 @@
             array_push($addresses_not_too_add, $project_details['prj_outgoing_sender_email']);
 
             if (!empty($to)) {
-                $to_addresses = Mail_API::getAddressInfo($to, true);
+                $to_addresses = Mail_Helper::getAddressInfo($to, true);
                 foreach ($to_addresses as $address) {
                     if ((in_array($address['email'], $addresses_not_too_add)) || (!Workflow::shouldEmailAddress($prj_id, $address['email']) ||
                             (!Workflow::shouldAutoAddToNotificationList($prj_id)))) {
@@ -958,14 +944,14 @@
                     if (empty($address['sender_name'])) {
                         $recipient = $address['email'];
                     } else {
-                        $recipient = Mail_API::getFormattedName($address['sender_name'], $address['email']);
+                        $recipient = Mail_Helper::getFormattedName($address['sender_name'], $address['email']);
                     }
                     Notification::subscribeEmail(Auth::getUserID(), $issue_id, $address['email'], Notification::getDefaultActions($issue_id, $recipient, 'issue_from_email'));
                     Notification::notifyAutoCreatedIssue($prj_id, $issue_id, $from, $date, $subject, $recipient);
                 }
             }
             if (!empty($cc)) {
-                $cc_addresses = Mail_API::getAddressInfo($cc, true);
+                $cc_addresses = Mail_Helper::getAddressInfo($cc, true);
                 foreach ($cc_addresses as $address) {
                     if ((in_array($address['email'], $addresses_not_too_add)) || (!Workflow::shouldEmailAddress($prj_id, $address['email']) ||
                             (!Workflow::shouldAutoAddToNotificationList($prj_id)))) {
@@ -974,7 +960,7 @@
                     if (empty($address['sender_name'])) {
                         $recipient = $address['email'];
                     } else {
-                        $recipient = Mail_API::getFormattedName($address['sender_name'], $address['email']);
+                        $recipient = Mail_Helper::getFormattedName($address['sender_name'], $address['email']);
                     }
                     Notification::subscribeEmail(Auth::getUserID(), $issue_id, $address['email'], Notification::getDefaultActions($issue_id, $recipient, 'issue_from_email'));
                     Notification::notifyAutoCreatedIssue($prj_id, $issue_id, $from, $date, $subject, $recipient);
@@ -1030,7 +1016,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_ema_id=" . Misc::escapeInteger($ema_id);
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -1055,7 +1041,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                 WHERE
                     sup_message_id = '" . Misc::escapeString($message_id) . "'";
-        $res = $GLOBALS["db_api"]->dbh->getOne($sql);
+        $res = Db_Helper::getInstance()->getOne($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1081,7 +1067,7 @@
     function insertEmail($row, &$structure, &$sup_id, $closing = false)
     {
         // get usr_id from FROM header
-        $usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($row['from']));
+        $usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($row['from']));
         if (!empty($usr_id) && !empty($row["customer_id"])) {
             $row["customer_id"] = User::getCustomerID($usr_id);
         }
@@ -1090,7 +1076,7 @@
         }
 
         // try to get the parent ID
-        $reference_message_id = Mail_API::getReferenceMessageID($row['full_email']);
+        $reference_message_id = Mail_Helper::getReferenceMessageID($row['full_email']);
         $parent_id = '';
         if (!empty($reference_message_id)) {
             $parent_id = Support::getIDByMessageID($reference_message_id);
@@ -1139,7 +1125,7 @@
                     '" . Misc::escapeString($row["subject"]) . "',
                     '" . Misc::escapeString($row["has_attachment"]) . "'
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1159,7 +1145,7 @@
                         '" . Misc::escapeString($row["body"]) . "',
                         '" . Misc::escapeString($row["full_email"]) . "'
                      )";
-            $res = $GLOBALS["db_api"]->dbh->query($stmt);
+            $res = Db_Helper::getInstance()->query($stmt);
             if (PEAR::isError($res)) {
                 Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
                 return -1;
@@ -1336,7 +1322,7 @@
         $stmt .= "
                  LIMIT
                     " . Misc::escapeInteger($start) . ", " . Misc::escapeInteger($max);
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array(
@@ -1360,13 +1346,13 @@
                 }
             }
             for ($i = 0; $i < count($res); $i++) {
-                $res[$i]["sup_date"] = Date_API::getFormattedDate($res[$i]["sup_date"]);
+                $res[$i]["sup_date"] = Date_Helper::getFormattedDate($res[$i]["sup_date"]);
                 $res[$i]["sup_subject"] = Mime_Helper::fixEncoding($res[$i]["sup_subject"]);
-                $res[$i]["sup_from"] = join(', ', Mail_API::getName($res[$i]["sup_from"], true));
+                $res[$i]["sup_from"] = join(', ', Mail_Helper::getName($res[$i]["sup_from"], true));
                 if ((empty($res[$i]["sup_to"])) && (!empty($res[$i]["sup_iss_id"]))) {
                     $res[$i]["sup_to"] = "Notification List";
                 } else {
-                    $to = Mail_API::getName($res[$i]["sup_to"]);
+                    $to = Mail_Helper::getName($res[$i]["sup_to"]);
                     if (PEAR::isError($to)) {
                         // ignore unformattable headers
                     } else {
@@ -1467,7 +1453,7 @@
         }
 
         // figure out who should be the 'owner' of this attachment
-        $sender_email = strtolower(Mail_API::getEmailAddress($input->headers['from']));
+        $sender_email = strtolower(Mail_Helper::getEmailAddress($input->headers['from']));
         $usr_id = User::getUserIDByEmail($sender_email);
         $unknown_user = false;
         if (empty($usr_id)) {
@@ -1524,7 +1510,7 @@
                     sup_iss_id=$issue_id
                  WHERE
                     sup_id IN (" . @implode(", ", Misc::escapeInteger($items)) . ")";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1541,7 +1527,7 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                      WHERE
                         sup_id IN (" . @implode(", ", Misc::escapeInteger($items)) . ")";
-            $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+            $res = Db_Helper::getInstance()->getCol($stmt);
             for ($i = 0; $i < count($res); $i++) {
                 History::add($issue_id, $usr_id, History::getTypeID('email_associated'),
                        ev_gettext('Email (subject: \'%1$s\') associated by %2$s', $res[$i], User::getFullName($usr_id)));
@@ -1575,7 +1561,7 @@
                      WHERE
                         sup_id=seb_sup_id AND
                         sup_id IN (" . @implode(", ", Misc::escapeInteger($items)) . ")";
-            $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+            $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
             for ($i = 0; $i < count($res); $i++) {
                 // since downloading email should make the emails 'public', send 'false' below as the 'internal_only' flag
                 $structure = Mime_Helper::decode($res[$i]['seb_full_email'], true, false);
@@ -1599,7 +1585,7 @@
                 );
                 Notification::notifyNewEmail($usr_id, $issue_id, $t, false, false, '', $res[$i]['sup_id']);
                 if ($authorize) {
-                    Authorized_Replier::manualInsert($issue_id, Mail_API::getEmailAddress(@$structure->headers['from']), false);
+                    Authorized_Replier::manualInsert($issue_id, Mail_Helper::getEmailAddress(@$structure->headers['from']), false);
                 }
             }
             return 1;
@@ -1629,22 +1615,22 @@
                     sup_id=seb_sup_id AND
                     sup_id=" . Misc::escapeInteger($sup_id) . " AND
                     sup_ema_id=" . Misc::escapeInteger($ema_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
         } else {
             $res['message'] = $res['seb_body'];
             $res["attachments"] = Mime_Helper::getAttachmentCIDs($res["seb_full_email"]);
-            $res["timestamp"] = Date_API::getUnixTimestamp($res['sup_date'], 'GMT');
-            $res["sup_date"] = Date_API::getFormattedDate($res["sup_date"]);
+            $res["timestamp"] = Date_Helper::getUnixTimestamp($res['sup_date'], 'GMT');
+            $res["sup_date"] = Date_Helper::getFormattedDate($res["sup_date"]);
             $res["sup_subject"] = Mime_Helper::fixEncoding($res["sup_subject"]);
-            $res['reply_subject'] = Mail_API::removeExcessRe('Re: ' . $res["sup_subject"], true);
+            $res['reply_subject'] = Mail_Helper::removeExcessRe('Re: ' . $res["sup_subject"], true);
             $res["sup_from"] = Mime_Helper::fixEncoding($res["sup_from"]);
             $res["sup_to"] = Mime_Helper::fixEncoding($res["sup_to"]);
 
             if (!empty($res['sup_iss_id'])) {
-                $res['reply_subject'] = Mail_API::formatSubject($res['sup_iss_id'], $res['reply_subject']);
+                $res['reply_subject'] = Mail_Helper::formatSubject($res['sup_iss_id'], $res['reply_subject']);
             }
 
             return $res;
@@ -1672,7 +1658,7 @@
                 ORDER BY
                     sup_id
                 LIMIT " . (Misc::escapeInteger($sequence) - 1) . ", 1";
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt);
+        $res = Db_Helper::getInstance()->getRow($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -1706,7 +1692,7 @@
                     ema_id=sup_ema_id AND
                     ema_prj_id=" . Auth::getCurrentProject() . " AND
                     sup_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1736,7 +1722,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email_body
                  WHERE
                     seb_sup_id=" . Misc::escapeInteger($sup_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1762,7 +1748,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email_body
                  WHERE
                     seb_sup_id=" . Misc::escapeInteger($sup_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1799,7 +1785,7 @@
                     sup_iss_id=" . Misc::escapeInteger($issue_id) . "
                  ORDER BY
                     sup_id ASC";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1808,7 +1794,7 @@
                 return "";
             } else {
                 for ($i = 0; $i < count($res); $i++) {
-                    $res[$i]["sup_date"] = Date_API::getFormattedDate($res[$i]["sup_date"]);
+                    $res[$i]["sup_date"] = Date_Helper::getFormattedDate($res[$i]["sup_date"]);
                     $res[$i]["sup_subject"] = Mime_Helper::fixEncoding($res[$i]["sup_subject"]);
                     $res[$i]["sup_from"] = Mime_Helper::fixEncoding($res[$i]["sup_from"]);
                     $res[$i]["sup_to"] = Mime_Helper::fixEncoding($res[$i]["sup_to"]);
@@ -1836,7 +1822,7 @@
                     sup_removed=1
                  WHERE
                     sup_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1862,7 +1848,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_id IN ($items)";
-        $issue_id = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $issue_id = Db_Helper::getInstance()->getOne($stmt);
 
         $stmt = "UPDATE
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
@@ -1870,7 +1856,7 @@
                     sup_iss_id=0
                  WHERE
                     sup_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1884,7 +1870,7 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                      WHERE
                         sup_id IN ($items)";
-            $subjects = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+            $subjects = Db_Helper::getInstance()->getAssoc($stmt);
             for ($i = 0; $i < count($_POST["item"]); $i++) {
                 History::add($issue_id, Auth::getUserID(), History::getTypeID('email_disassociated'),
                                 ev_gettext('Email (subject: \'%1$s\') disassociated by %2$s', $subjects[$_POST["item"][$i]], User::getFullName(Auth::getUserID())));
@@ -1969,7 +1955,7 @@
     function buildFullHeaders($issue_id, $message_id, $from, $to, $cc, $subject, $body, $in_reply_to, $attachments = null)
     {
         // hack needed to get the full headers of this web-based email
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($body);
 
         $body = $mail->mime->get(array('text_charset' => APP_CHARSET, 'head_charset' => APP_CHARSET, 'text_encoding' => APP_EMAIL_ENCODING));
@@ -2031,20 +2017,20 @@
     function sendDirectEmail($issue_id, $from, $to, $cc, $subject, $body, $attachment, $message_id, $sender_usr_id = false)
     {
         $prj_id = Issue::getProjectID($issue_id);
-        $subject = Mail_API::formatSubject($issue_id, $subject);
+        $subject = Mail_Helper::formatSubject($issue_id, $subject);
         $recipients = Support::getRecipientsCC($cc);
         $recipients[] = $to;
         // send the emails now, one at a time
         foreach ($recipients as $recipient) {
-            $mail = new Mail_API;
+            $mail = new Mail_Helper;
             if (!empty($issue_id)) {
                 // add the warning message to the current message' body, if needed
-                $fixed_body = Mail_API::addWarningMessage($issue_id, $recipient, $body, array());
+                $fixed_body = Mail_Helper::addWarningMessage($issue_id, $recipient, $body, array());
                 $mail->setHeaders(array(
                     "Message-Id" => $message_id
                 ));
                 // skip users who don't have access to this issue (but allow non-users and users without access to this project) to get emails
-                $recipient_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($recipient), true);
+                $recipient_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($recipient), true);
                 if ((((!empty($recipient_usr_id)) && ((!Issue::canAccess($issue_id, $recipient_usr_id)) && (User::getRoleByUser($recipient_usr_id, $prj_id) != NULL)))) ||
                         (empty($recipient_usr_id)) && (Issue::isPrivate($issue_id))) {
                     continue;
@@ -2052,7 +2038,7 @@
             } else {
                 $fixed_body = $body;
             }
-            if (User::getRoleByUser(User::getUserIDByEmail(Mail_API::getEmailAddress($from)), Issue::getProjectID($issue_id)) == User::getRoleID("Customer")) {
+            if (User::getRoleByUser(User::getUserIDByEmail(Mail_Helper::getEmailAddress($from)), Issue::getProjectID($issue_id)) == User::getRoleID("Customer")) {
                 $type = 'customer_email';
             } else {
                 $type = 'other_email';
@@ -2104,7 +2090,7 @@
         }
 
         // get ID of whoever is sending this.
-        $sender_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($_POST["from"]));
+        $sender_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($_POST["from"]));
         if (empty($sender_usr_id)) {
             $sender_usr_id = false;
         }
@@ -2118,9 +2104,9 @@
 
 
         // remove extra 'Re: ' from subject
-        $_POST['subject'] = Mail_API::removeExcessRe($_POST['subject'], true);
+        $_POST['subject'] = Mail_Helper::removeExcessRe($_POST['subject'], true);
         $internal_only = false;
-        $message_id = Mail_API::generateMessageID();
+        $message_id = Mail_Helper::generateMessageID();
         // hack needed to get the full headers of this web-based email
         $full_email = Support::buildFullHeaders($_POST["issue_id"], $message_id, $_POST["from"],
                 $_POST["to"], $_POST["cc"], $_POST["subject"], $_POST["message"], $in_reply_to, $_FILES["attachment"]);
